

var last_updated = 0;
var xml_request = null;
var title = null;

//entry point.
function show ()
{
	var now = (new Date).getTime();
	// only check if 15 minutes have passed
	if ((now - last_updated) > 900000)
	{
		title = (document.getElementById('postTitle') ? document.getElementById('postTitle').innerHTML : null);
		if (xml_request != null)
		{
			xml_request.abort();
			xml_request = null;
		}
		xml_request = new XMLHttpRequest();

		xml_request.onreadystatechange = processReqChange;
		xml_request.open("GET", "http://feedproxy.google.com/OpticalIllusions",true);
		xml_request.setRequestHeader('If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT');
		xml_request.overrideMimeType('text/xml');
		xml_request.send("");
    }
}

if (window.widget)
{
	widget.onshow = show;
}
else
{
    show();
}

//called by XMLHttpRequest when state changes.
function processReqChange()
{
    if(xml_request.readyState==4)
    {
        if (xml_request.status == 200) xml_loaded(xml_request);
        else 
        {
             document.getElementById('postTitle').innerHTML = (title == null ? "No Internet!" : title);
        }
        
    }
    else if(xml_request.readyState==2) document.getElementById("postTitle").innerHTML="Loading...";
}

//parses RSS
function xml_loaded (request) 
{

	xml_request = null;
	/*if (request.responseText) {			
		// get the first entry that has a pic in it and display. 
		var title=null;
		var link=null;
		var img=null;
		var done=false;
		var entry = request.responseText.split("<entry>")[1].split("</entry>")[0];
		title = entry.split("<title type='text'>")[1].split("</title>")[0];
		link = entry.split("<link rel='alternate' type='text/html' href='")[1].split("'></link>")[0];
		img = entry.split("src=\"")[1].split("\"")[0];
		last_updated = (new Date).getTime();
	}*/
	if (request.responseXML) {
		/* // Get the top level <rss> element 
		var rss = findChild(request.responseXML, 'rss');
		if (!rss) {
			alert("no <rss> element"); 
			return;
		}
		
		// Get single channel element
		var channel = findChild( rss, 'channel');
		if (!channel) {
			alert("no <channel> element");
			return;
		}*/
		var channel = request.responseXML.getElementsByTagName("feed")[0];//findChild(request.responseXML, 'channel');
		if(!channel) {
			alert("no <feed> element");
			return;
		}
		
				
		// get the first entry that has a pic in it and display. 
		var title=null;
		var link=null;
		var img=null;
		var done=false;
		for( var item = channel.firstChild; (item != null)&&(done==false); item = item.nextSibling)
		{
			if( item.nodeName == 'entry' ) 
			{
				var titleNode = findChild (item, 'title');
			
				// we have to have the title to include the item in the list 
				if( titleNode != null ) 
				{
					var linkNode = findChild (item, 'feedburner:origLink');
					var descriptionNode= findChild(item,'content'); 
					
					title=unescape(titleNode.firstChild.data);
					link=linkNode.firstChild.data;//getAttribute('href');
					var parts=descriptionNode.firstChild.data.split("src=\"");
					img=parts[1].split("\"")[0];
					done= img!=null;
				}
			}
		}
		last_updated = (new Date).getTime();
	}
	document.getElementById("pic").src = img;
	//make sure the title isn't too long
	if(title.length > 22)
	{
	   title = title.substr(0,21) + "...";
	}
	document.getElementById("postTitle").innerHTML = title;
	url2 = link;
}

var url2 = "http://www.moillusions.com";

var url1 = "http://www.moillusions.com";
//go to the url
function go2()
{
    if (window.widget) widget.openURL (url2);
	else document.location = url2;
}
//go to the main site
function go1()
{
    if (window.widget) widget.openURL (url1);
	else document.location = url1;
}

function findChild (element, nodeName)
{
	for (var child = element.firstChild; child != null; child = child.nextSibling)
		if (child.nodeName == nodeName) return child;
	return null;
}
